• Codeforces Round #369 (Div. 2) C. Coloring Trees DP


    C. Coloring Trees
     

    ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

    Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

    ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

    The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

    ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

    Please note that the friends can't color the trees that are already colored.

    Input

    The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

    The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

    Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

    Output

    Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

    Examples
    input
    3 2 2
    0 0 0
    1 2
    3 4
    5 6
    output
    10
     
    Note

    In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

    In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

    In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

    题意:

      给你n棵树

      每个树上可能已经填了颜色,可能没有填颜色(0)

      现在告诉你有m种颜色,让分成 K 块

      给你每棵树填每种颜色的花费

      问你分成K块的最小花费

    题解:

      设定dp[i][j][k]表示第i棵树 时 填的j颜色 分成k块 的 最小花费

      n^4去转移不会超时

      可是 我们可以 把最后两维放到 线段树优化

      这样就是n^3 log

    #include<bits/stdc++.h>
    using namespace std;
    
    #pragma comment(linker, "/STACK:102400000,102400000")
    #define ls i<<1
    #define rs ls | 1
    #define mid ((ll+rr)>>1)
    #define pii pair<int,int>
    #define MP make_pair
    
    typedef long long LL;
    const long long INF = 1e18;
    const double Pi = acos(-1.0);
    const int N = 1e2+10, M = 1e6+11, mod = 1e6+3;
    
    const LL inf = 1e15;
    
    int n,k,m;
    
    LL a[N];
    
    LL dp[N][N][N];
    LL mi[N<<4][N<<4];
    LL v[N][N];
    
    void build(int K,int i,int ll,int rr) {
        mi[K][i] = inf;
        if(ll == rr) {
            return ;
        }
        build(K,ls,ll,mid);
        build(K,rs,mid+1,rr);
    }
    
    void update(int K,int i,int ll,int rr,int x,LL c) {
            if(ll == rr && x == ll) {
                mi[K][i] = c;return ;
            }
            if(x <= mid) update(K,ls,ll,mid,x,c);
            else if(x > mid) update(K,rs,mid+1,rr,x,c);
            mi[K][i] = min(mi[K][ls],mi[K][rs]);
    }
    
    LL ask(int K,int i,int ll,int rr,int l,int r,int op,int x) {
        if(l > r) return inf;
        if(ll == l && r == rr) {
            return mi[K][i];
        }
        if(r <= mid) return ask(K,ls,ll,mid,l,r,op,x);
        else if(l > mid) return ask(K,rs,mid+1,rr,l,r,op,x);
        else return min(ask(K,ls,ll,mid,l,mid,op,x), ask(K,rs,mid+1,rr,mid+1,r,op,x));
    }
    
    
    int main ( ) {
            scanf("%d%d%d",&n,&m,&k);
            for(int i = 1; i <= n; ++i) scanf("%I64d",&a[i]);
            for(int i = 1; i <= n; ++i) {
                for(int j = 1; j <= m; ++j) scanf("%I64d",&v[i][j]);
            }
    
            for(int i = 0; i <= 100; ++i) {
                for(int j = 0; j <= 100; ++j) {
                    for(int K = 0; K <= 100; ++K) dp[i][j][K] = inf;
                }
            }
    
            for(int i = 1; i <= k; i++) {
                build(i,1,1,m);
            }
    
            if(a[1] == 0) {
                for(int i = 1; i <= m; i++) dp[1][i][1] = v[1][i];
            } else dp[1][a[1]][1] = 0;
    
    
            for(int i = 1; i <= m; ++i) {
                update(1,1,1,m,i,dp[1][i][1]);
            }
    
            for(int i = 2; i <= n; ++i) {
                if(a[i] == 0) {
                    for(int j = 1; j <= m; ++j) {
                        for(int K = 1; K <= k; ++K){
                            if(K != 1 ) {
                                  if(j!=1&&j!=m)dp[i][j][K] = min(min(ask(K-1,1,1,m,1,j-1,i,j),ask(K-1,1,1,m,j+1,m,i,j))+v[i][j],dp[i][j][K]);
                                else if(j == 1) dp[i][j][K] = min(ask(K-1,1,1,m,2,m,i,j)+v[i][j],dp[i][j][K]);
                                else dp[i][j][K] = min(ask(K-1,1,1,m,1,m-1,i,j)+v[i][j],dp[i][j][K]);
                            }
                            dp[i][j][K] = min( dp[i][j][K],dp[i-1][j][K] + v[i][j]);
                        }
                    }
                }
                else {
                    for(int K = 1; K <= k; ++K)
                    {
                        if(K != 1) {
                            if(a[i] == 1) dp[i][a[i]][K] = min(ask(K-1,1,1,m,2,m,i,1),dp[i][a[i]][K]);
                            else if(a[i] == m) dp[i][a[i]][K] = min(ask(K-1,1,1,m,1,m-1,i,1),dp[i][a[i]][K]);
                            else dp[i][a[i]][K] = min(min(ask(K-1,1,1,m,1,a[i]-1,i,1),ask(K-1,1,1,m,a[i]+1,m,i,1)),dp[i][a[i]][K]);
                        }
                        dp[i][a[i]][K] = min(dp[i-1][a[i]][K],dp[i][a[i]][K]);
                    }
                }
    
                for(int K = 1; K <= k; ++K) for(int j = 1; j <= m; j++) update(K,1,1,m,j,dp[i][j][K]);
            }
    
            LL ans = ask(k,1,1,m,1,m,n+1,1);
            if( ans >= inf) puts("-1");
            else
            printf("%I64d
    ",ans);
    }
    n^3 log

      n^4:

    #include<bits/stdc++.h>
    using namespace std;
    typedef long long int uli;
    const uli oo=1e15;
    uli f[2][123][123];
    uli p[123][123];
    int color[123];
    int main(){
       int n,m,k;
       scanf("%d %d %d",&n,&m,&k);
       for(int i=0;i<n;i++)scanf("%d",color+i);
       for(int i=0;i<n;i++)
          for(int j=1;j<=m;j++)
             scanf("%lld",&p[i][j]);
       for(int i=0;i<n;i++)if(color[i]!=0)p[i][color[i]]=0;
       int rw=0; 
       for(int c=0;c<123;c++){
          for(int q=0;q<123;q++)f[rw][c][q]=oo;
          f[rw][c][0]=0;
       }
       for(int i=0;i<n;i++){
          rw^=1;
          int from=1,to=m;
          if(color[i]!=0)from=to=color[i];
          for(int c=0;c<=m;c++){
             for(int q=0;q<=k;q++){
                f[rw][c][q]=oo;
                for(int x=from;x<=to;x++){
                   int nq=q-(x!=c);
                   if(nq>=0)f[rw][c][q]=min(f[rw][c][q],f[rw^1][x][nq]+p[i][x]);
                }
             }
          }
       }
       uli ans=f[rw][0][k];
       if(ans>=oo)ans=-1;
       printf("%lld
    ",ans);
       return 0;
    }

      

  • 相关阅读:
    TWaver HTML5 (2D)--基本概念
    浏览器编码的函数简介escape(),encodeURI(),encodeURIComponent()
    pom.xml
    注解式控制器简介
    Controller接口
    WebContentGenerator
    Controller简介
    DispatcherServlet中使用的特殊的Bean
    DispatcherServlet默认配置
    DispatcherServlet
  • 原文地址:https://www.cnblogs.com/zxhl/p/5821100.html
Copyright © 2020-2023  润新知